---
product: "AG Charts"
title: "Overlays"
description: "There are some options to display custom HTML over a chart."
framework: javascript
version: "14.2.0"
related:
    - title: "Background"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/background/"
    - title: "Colours"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/colours/"
    - title: "Fills & Borders"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/fills-borders/"
    - title: "Layout"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/layout/"
    - title: "RTL Text & Layout"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/rtl/"
    - title: "Text"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/text/"
    - title: "Themes"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/themes/"
    - title: "Background Image"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/background-image/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Overlays

There are some options to display custom HTML over a chart.

## Missing Data Overlay

Sometimes end-users can be confused if a chart doesn't have any content. To help them understand that no data has been supplied, a message is displayed over the chart area.

#### Overlay for Missing Data

```ts
import {
  AgChartOptions,
  AgCharts,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";

ModuleRegistry.registerModules([
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const options: AgChartOptions = {
  title: {
    text: "A chart with missing data",
  },
  data: [],
  series: [
    {
      type: "line",
      xKey: "year",
      yKey: "spending",
    },
  ],
  axes: {
    y: { type: "number", title: { text: "Year" } },
    x: { type: "number", title: { text: "Spending" } },
  },
  overlays: {
    noData: {
      text: "No data to display",
    },
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Overlay for Missing Data](https://www.ag-grid.com/charts/archive/14.2.0/typescript/overlays/examples/no-data-plain/)

## No Visible Series Overlay

A message is also displayed when all series are hidden:

#### No Visible Series

```ts
import {
  AgChartOptions,
  AgCharts,
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";

ModuleRegistry.registerModules([
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const options: AgChartOptions = {
  data: [
    { quarter: "Q1", petrol: 200, diesel: 100 },
    { quarter: "Q2", petrol: 300, diesel: 130 },
    { quarter: "Q3", petrol: 350, diesel: 160 },
    { quarter: "Q4", petrol: 400, diesel: 200 },
  ],
  series: [
    { type: "line", xKey: "quarter", yKey: "petrol", visible: false },
    { type: "line", xKey: "quarter", yKey: "diesel", visible: false },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: No Visible Series](https://www.ag-grid.com/charts/archive/14.2.0/typescript/overlays/examples/no-visible-series/)

## Loading Data Overlay

When using [Asynchronous Data](https://www.ag-grid.com/charts/archive/14.2.0/javascript/async-data/), a loading data animation is shown while waiting for a response. The overlay can also be shown or hidden manually using the `loading` option. See [Asynchronous Data — Manual Control](https://www.ag-grid.com/charts/archive/14.2.0/javascript/async-data/#manual-control) for details.

#### Loading Data

```ts
import {
  AgChartOptions,
  AgCharts,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  DataSourceModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-enterprise";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  DataSourceModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ContextMenuModule,
]);

const options: AgChartOptions = {
  dataSource: {
    getData: () =>
      new Promise(() => {
        // Never resolve so the loading spinner remains
      }),
  },
  series: [
    {
      type: "line",
      xKey: "year",
      yKey: "spending",
    },
  ],
  axes: {
    y: { type: "number", title: { text: "Year" } },
    x: { type: "number", title: { text: "Spending" } },
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Loading Data](https://www.ag-grid.com/charts/archive/14.2.0/typescript/overlays/examples/loading/)

## Unsupported Browser Overlay

When an [unsupported browser](https://www.ag-grid.com/charts/archive/14.2.0/javascript/supported-browsers/) is detected and the chart may not operate correctly, we display an overlay to make the user aware of this.

## Customisation

### Text

These messages can be customised through `overlays`:

```js
{
    overlays: {
        loading: {
            text: 'Some custom loading message',
        },
        noData: {
            text: 'Some custom noData message',
        },
        noVisibleSeries: {
            text: 'Some custom noVisibleSeries message',
        },
        unsupportedBrowser: {
            text: 'Some custom unsupportedBrowser message',
        },
    },
}
```

### Custom Overlay

If finer grained control is required, a renderer can be provided to allow full customisation:

#### Custom Overlay for Missing Data

```ts
import {
  AgChartOptions,
  AgCharts,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";

const noDataOverlay = () => {
  return [
    "<div",
    '    style="',
    "        align-items: center;",
    "        background: hsl(45deg, 100%, 90%);",
    "        border: 2px solid hsl(0deg, 100%, 75%);",
    "        box-sizing: border-box;",
    "        color: black;",
    "        display: flex;",
    "        height: calc(100% - 16px);",
    "        justify-content: center;",
    "        margin: 8px;",
    '    "',
    ">",
    "    <em>Custom message for <strong>missing data</strong></em>",
    "</div>",
  ].join("\n");
};
ModuleRegistry.registerModules([
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const options: AgChartOptions = {
  title: {
    text: "A chart with missing data",
  },
  data: [],
  series: [
    {
      type: "line",
      xKey: "year",
      yKey: "spending",
    },
  ],
  axes: {
    y: { type: "number", title: { text: "Year" } },
    x: { type: "number", title: { text: "Spending" } },
  },
  overlays: {
    noData: {
      renderer: noDataOverlay,
    },
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Custom Overlay for Missing Data](https://www.ag-grid.com/charts/archive/14.2.0/typescript/overlays/examples/no-data/)

```js
{
    overlays: {
        noData: {
            renderer: () => '<em>Custom message for <strong>missing data</strong></em>',
        },
    },
}
```

### Custom Loading Spinner

#### Custom Overlay for Loading Data

```ts
import {
  AgChartOptions,
  AgCharts,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  DataSourceModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-enterprise";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  DataSourceModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ContextMenuModule,
]);

const options: AgChartOptions = {
  dataSource: {
    getData: () =>
      new Promise(() => {
        // Never resolve so the loading spinner remains
      }),
  },
  overlays: {
    loading: {
      renderer: () => {
        const container = document.createElement("div");
        container.style.display = "flex";
        container.style.justifyContent = "center";
        container.style.alignItems = "center";
        container.style.flexDirection = "column";
        container.style.height = "100%";
        container.style.boxSizing = "border-box";
        container.style.userSelect = "none";
        container.style.animation = "loading 250ms linear 50ms both";
        const spinner = document.createElement("div");
        spinner.style.width = "100px";
        spinner.style.height = "100px";
        spinner.style.backgroundImage = [
          "linear-gradient(#333, #333)",
          "linear-gradient(#999, #999)",
          "linear-gradient(#ccc, #ccc)",
        ].join(", ");
        spinner.style.backgroundPosition = "0% 0%, 0% 100%, 100% 100%";
        spinner.style.backgroundSize = "50% 50%";
        spinner.style.backgroundRepeat = "no-repeat";
        spinner.style.animation = "loading-spinner 1s infinite";
        const animation = document.createElement("style");
        animation.innerText = [
          "@keyframes loading { from { opacity: 0 } to { opacity: 1 } }",
          "@keyframes loading-spinner {",
          "  0% { background-position: 0% 0%, 0% 100%, 100% 100%; }",
          "  25% { background-position: 100% 0%, 0% 0%, 0% 100%; }",
          "  50% { background-position: 100% 100%, 100% 0%, 0% 0%; }",
          "  75% { background-position: 0% 100%, 100% 100%, 100% 0%; }",
          "  100% { background-position: 0% 0%, 0% 100%, 100% 100%; }",
          "}",
        ].join(" ");
        container.replaceChildren(spinner, animation);
        return container;
      },
    },
  },
  series: [
    {
      type: "line",
      xKey: "year",
      yKey: "spending",
    },
  ],
  axes: {
    y: { type: "number", title: { text: "Year" } },
    x: { type: "number", title: { text: "Spending" } },
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Custom Overlay for Loading Data](https://www.ag-grid.com/charts/archive/14.2.0/typescript/overlays/examples/loading-custom/)

```js
{
    overlays: {
        loading: {
            renderer: () => {
                const container = document.createElement('div');
                // ... styles

                const spinner = document.createElement('div');
                // ... styles

                const animation = document.createElement('style');
                // ... keyframes

                container.append(spinner, animation);

                return container;
            },
        },
    },
}
```

## API Reference

#### Overlays

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| loading | AgChartOverlayOptions |  | An overlay to be displayed when there is no data. |
| loading.enabled | boolean | true | Enabled or disable use of the overlay. |
| loading.text | TextValue \| ContentSegment[] |  | Text to render in the overlay. Plain text, or an array of segments for rich content. |
| loading.renderer | Renderer |  | A function for generating HTML element or string for overlay content. |
| noData | AgChartOverlayOptions |  | An overlay to be displayed when there is no data. |
| noData.enabled | boolean | true | Enabled or disable use of the overlay. |
| noData.text | TextValue \| ContentSegment[] |  | Text to render in the overlay. Plain text, or an array of segments for rich content. |
| noData.renderer | Renderer |  | A function for generating HTML element or string for overlay content. |
| noVisibleSeries | AgChartOverlayOptions |  | An overlay to be displayed when there are no series visible. |
| noVisibleSeries.enabled | boolean | true | Enabled or disable use of the overlay. |
| noVisibleSeries.text | TextValue \| ContentSegment[] |  | Text to render in the overlay. Plain text, or an array of segments for rich content. |
| noVisibleSeries.renderer | Renderer |  | A function for generating HTML element or string for overlay content. |
| unsupportedBrowser | AgChartOverlayOptions |  | An overlay to be displayed when chart is running in an unsupported browser. |
| unsupportedBrowser.enabled | boolean | true | Enabled or disable use of the overlay. |
| unsupportedBrowser.text | TextValue \| ContentSegment[] |  | Text to render in the overlay. Plain text, or an array of segments for rich content. |
| unsupportedBrowser.renderer | Renderer |  | A function for generating HTML element or string for overlay content. |


---
product: "AG Charts"
title: "Overlays"
description: "There are some options to display custom HTML over a chart."
framework: angular
version: "14.2.0"
related:
    - title: "Background"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/background/"
    - title: "Colours"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/colours/"
    - title: "Fills & Borders"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/fills-borders/"
    - title: "Layout"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/layout/"
    - title: "RTL Text & Layout"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/rtl/"
    - title: "Text"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/text/"
    - title: "Themes"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/themes/"
    - title: "Background Image"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/background-image/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Overlays

There are some options to display custom HTML over a chart.

## Missing Data Overlay

Sometimes end-users can be confused if a chart doesn't have any content. To help them understand that no data has been supplied, a message is displayed over the chart area.

#### Overlay for Missing Data

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Overlay for Missing Data](https://www.ag-grid.com/charts/archive/14.2.0/angular/overlays/examples/no-data-plain/)

## No Visible Series Overlay

A message is also displayed when all series are hidden:

#### No Visible Series

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: No Visible Series](https://www.ag-grid.com/charts/archive/14.2.0/angular/overlays/examples/no-visible-series/)

## Loading Data Overlay

When using [Asynchronous Data](https://www.ag-grid.com/charts/archive/14.2.0/angular/async-data/), a loading data animation is shown while waiting for a response. The overlay can also be shown or hidden manually using the `loading` option. See [Asynchronous Data — Manual Control](https://www.ag-grid.com/charts/archive/14.2.0/angular/async-data/#manual-control) for details.

#### Loading Data

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Loading Data](https://www.ag-grid.com/charts/archive/14.2.0/angular/overlays/examples/loading/)

## Unsupported Browser Overlay

When an [unsupported browser](https://www.ag-grid.com/charts/archive/14.2.0/angular/supported-browsers/) is detected and the chart may not operate correctly, we display an overlay to make the user aware of this.

## Customisation

### Text

These messages can be customised through `overlays`:

```js
{
    overlays: {
        loading: {
            text: 'Some custom loading message',
        },
        noData: {
            text: 'Some custom noData message',
        },
        noVisibleSeries: {
            text: 'Some custom noVisibleSeries message',
        },
        unsupportedBrowser: {
            text: 'Some custom unsupportedBrowser message',
        },
    },
}
```

### Custom Overlay

If finer grained control is required, a renderer can be provided to allow full customisation:

#### Custom Overlay for Missing Data

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Custom Overlay for Missing Data](https://www.ag-grid.com/charts/archive/14.2.0/angular/overlays/examples/no-data/)

```js
{
    overlays: {
        noData: {
            renderer: () => '<em>Custom message for <strong>missing data</strong></em>',
        },
    },
}
```

### Custom Loading Spinner

#### Custom Overlay for Loading Data

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Custom Overlay for Loading Data](https://www.ag-grid.com/charts/archive/14.2.0/angular/overlays/examples/loading-custom/)

```js
{
    overlays: {
        loading: {
            renderer: () => {
                const container = document.createElement('div');
                // ... styles

                const spinner = document.createElement('div');
                // ... styles

                const animation = document.createElement('style');
                // ... keyframes

                container.append(spinner, animation);

                return container;
            },
        },
    },
}
```

## API Reference

#### Overlays

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| loading | AgChartOverlayOptions |  | An overlay to be displayed when there is no data. |
| loading.enabled | boolean | true | Enabled or disable use of the overlay. |
| loading.text | TextValue \| ContentSegment[] |  | Text to render in the overlay. Plain text, or an array of segments for rich content. |
| loading.renderer | Renderer |  | A function for generating HTML element or string for overlay content. |
| noData | AgChartOverlayOptions |  | An overlay to be displayed when there is no data. |
| noData.enabled | boolean | true | Enabled or disable use of the overlay. |
| noData.text | TextValue \| ContentSegment[] |  | Text to render in the overlay. Plain text, or an array of segments for rich content. |
| noData.renderer | Renderer |  | A function for generating HTML element or string for overlay content. |
| noVisibleSeries | AgChartOverlayOptions |  | An overlay to be displayed when there are no series visible. |
| noVisibleSeries.enabled | boolean | true | Enabled or disable use of the overlay. |
| noVisibleSeries.text | TextValue \| ContentSegment[] |  | Text to render in the overlay. Plain text, or an array of segments for rich content. |
| noVisibleSeries.renderer | Renderer |  | A function for generating HTML element or string for overlay content. |
| unsupportedBrowser | AgChartOverlayOptions |  | An overlay to be displayed when chart is running in an unsupported browser. |
| unsupportedBrowser.enabled | boolean | true | Enabled or disable use of the overlay. |
| unsupportedBrowser.text | TextValue \| ContentSegment[] |  | Text to render in the overlay. Plain text, or an array of segments for rich content. |
| unsupportedBrowser.renderer | Renderer |  | A function for generating HTML element or string for overlay content. |


---
product: "AG Charts"
title: "Overlays"
description: "There are some options to display custom HTML over a chart."
framework: vue
version: "14.2.0"
related:
    - title: "Background"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/background/"
    - title: "Colours"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/colours/"
    - title: "Fills & Borders"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/fills-borders/"
    - title: "Layout"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/layout/"
    - title: "RTL Text & Layout"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/rtl/"
    - title: "Text"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/text/"
    - title: "Themes"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/themes/"
    - title: "Background Image"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/background-image/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Overlays

There are some options to display custom HTML over a chart.

## Missing Data Overlay

Sometimes end-users can be confused if a chart doesn't have any content. To help them understand that no data has been supplied, a message is displayed over the chart area.

#### Overlay for Missing Data

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";

ModuleRegistry.registerModules([
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgChartOptions>({
      title: {
        text: "A chart with missing data",
      },
      data: [],
      series: [
        {
          type: "line",
          xKey: "year",
          yKey: "spending",
        },
      ],
      axes: {
        y: { type: "number", title: { text: "Year" } },
        x: { type: "number", title: { text: "Spending" } },
      },
      overlays: {
        noData: {
          text: "No data to display",
        },
      },
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Overlay for Missing Data](https://www.ag-grid.com/charts/archive/14.2.0/vue3/overlays/examples/no-data-plain/)

## No Visible Series Overlay

A message is also displayed when all series are hidden:

#### No Visible Series

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";

ModuleRegistry.registerModules([
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgChartOptions>({
      data: [
        { quarter: "Q1", petrol: 200, diesel: 100 },
        { quarter: "Q2", petrol: 300, diesel: 130 },
        { quarter: "Q3", petrol: 350, diesel: 160 },
        { quarter: "Q4", petrol: 400, diesel: 200 },
      ],
      series: [
        { type: "line", xKey: "quarter", yKey: "petrol", visible: false },
        { type: "line", xKey: "quarter", yKey: "diesel", visible: false },
      ],
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: No Visible Series](https://www.ag-grid.com/charts/archive/14.2.0/vue3/overlays/examples/no-visible-series/)

## Loading Data Overlay

When using [Asynchronous Data](https://www.ag-grid.com/charts/archive/14.2.0/vue/async-data/), a loading data animation is shown while waiting for a response. The overlay can also be shown or hidden manually using the `loading` option. See [Asynchronous Data — Manual Control](https://www.ag-grid.com/charts/archive/14.2.0/vue/async-data/#manual-control) for details.

#### Loading Data

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  DataSourceModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-enterprise";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  DataSourceModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ContextMenuModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgChartOptions>({
      dataSource: {
        getData: () =>
          new Promise(() => {
            // Never resolve so the loading spinner remains
          }),
      },
      series: [
        {
          type: "line",
          xKey: "year",
          yKey: "spending",
        },
      ],
      axes: {
        y: { type: "number", title: { text: "Year" } },
        x: { type: "number", title: { text: "Spending" } },
      },
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Loading Data](https://www.ag-grid.com/charts/archive/14.2.0/vue3/overlays/examples/loading/)

## Unsupported Browser Overlay

When an [unsupported browser](https://www.ag-grid.com/charts/archive/14.2.0/vue/supported-browsers/) is detected and the chart may not operate correctly, we display an overlay to make the user aware of this.

## Customisation

### Text

These messages can be customised through `overlays`:

```js
{
    overlays: {
        loading: {
            text: 'Some custom loading message',
        },
        noData: {
            text: 'Some custom noData message',
        },
        noVisibleSeries: {
            text: 'Some custom noVisibleSeries message',
        },
        unsupportedBrowser: {
            text: 'Some custom unsupportedBrowser message',
        },
    },
}
```

### Custom Overlay

If finer grained control is required, a renderer can be provided to allow full customisation:

#### Custom Overlay for Missing Data

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";

const noDataOverlay = () => {
  return [
    "<div",
    '    style="',
    "        align-items: center;",
    "        background: hsl(45deg, 100%, 90%);",
    "        border: 2px solid hsl(0deg, 100%, 75%);",
    "        box-sizing: border-box;",
    "        color: black;",
    "        display: flex;",
    "        height: calc(100% - 16px);",
    "        justify-content: center;",
    "        margin: 8px;",
    '    "',
    ">",
    "    <em>Custom message for <strong>missing data</strong></em>",
    "</div>",
  ].join("\n");
};

ModuleRegistry.registerModules([
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgChartOptions>({
      title: {
        text: "A chart with missing data",
      },
      data: [],
      series: [
        {
          type: "line",
          xKey: "year",
          yKey: "spending",
        },
      ],
      axes: {
        y: { type: "number", title: { text: "Year" } },
        x: { type: "number", title: { text: "Spending" } },
      },
      overlays: {
        noData: {
          renderer: noDataOverlay,
        },
      },
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Custom Overlay for Missing Data](https://www.ag-grid.com/charts/archive/14.2.0/vue3/overlays/examples/no-data/)

```js
{
    overlays: {
        noData: {
            renderer: () => '<em>Custom message for <strong>missing data</strong></em>',
        },
    },
}
```

### Custom Loading Spinner

#### Custom Overlay for Loading Data

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  DataSourceModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-enterprise";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  DataSourceModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ContextMenuModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgChartOptions>({
      dataSource: {
        getData: () =>
          new Promise(() => {
            // Never resolve so the loading spinner remains
          }),
      },
      overlays: {
        loading: {
          renderer: () => {
            const container = document.createElement("div");
            container.style.display = "flex";
            container.style.justifyContent = "center";
            container.style.alignItems = "center";
            container.style.flexDirection = "column";
            container.style.height = "100%";
            container.style.boxSizing = "border-box";
            container.style.userSelect = "none";
            container.style.animation = "loading 250ms linear 50ms both";
            const spinner = document.createElement("div");
            spinner.style.width = "100px";
            spinner.style.height = "100px";
            spinner.style.backgroundImage = [
              "linear-gradient(#333, #333)",
              "linear-gradient(#999, #999)",
              "linear-gradient(#ccc, #ccc)",
            ].join(", ");
            spinner.style.backgroundPosition = "0% 0%, 0% 100%, 100% 100%";
            spinner.style.backgroundSize = "50% 50%";
            spinner.style.backgroundRepeat = "no-repeat";
            spinner.style.animation = "loading-spinner 1s infinite";
            const animation = document.createElement("style");
            animation.innerText = [
              "@keyframes loading { from { opacity: 0 } to { opacity: 1 } }",
              "@keyframes loading-spinner {",
              "  0% { background-position: 0% 0%, 0% 100%, 100% 100%; }",
              "  25% { background-position: 100% 0%, 0% 0%, 0% 100%; }",
              "  50% { background-position: 100% 100%, 100% 0%, 0% 0%; }",
              "  75% { background-position: 0% 100%, 100% 100%, 100% 0%; }",
              "  100% { background-position: 0% 0%, 0% 100%, 100% 100%; }",
              "}",
            ].join(" ");
            container.replaceChildren(spinner, animation);
            return container;
          },
        },
      },
      series: [
        {
          type: "line",
          xKey: "year",
          yKey: "spending",
        },
      ],
      axes: {
        y: { type: "number", title: { text: "Year" } },
        x: { type: "number", title: { text: "Spending" } },
      },
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Custom Overlay for Loading Data](https://www.ag-grid.com/charts/archive/14.2.0/vue3/overlays/examples/loading-custom/)

```js
{
    overlays: {
        loading: {
            renderer: () => {
                const container = document.createElement('div');
                // ... styles

                const spinner = document.createElement('div');
                // ... styles

                const animation = document.createElement('style');
                // ... keyframes

                container.append(spinner, animation);

                return container;
            },
        },
    },
}
```

## API Reference

#### Overlays

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| loading | AgChartOverlayOptions |  | An overlay to be displayed when there is no data. |
| loading.enabled | boolean | true | Enabled or disable use of the overlay. |
| loading.text | TextValue \| ContentSegment[] |  | Text to render in the overlay. Plain text, or an array of segments for rich content. |
| loading.renderer | Renderer |  | A function for generating HTML element or string for overlay content. |
| noData | AgChartOverlayOptions |  | An overlay to be displayed when there is no data. |
| noData.enabled | boolean | true | Enabled or disable use of the overlay. |
| noData.text | TextValue \| ContentSegment[] |  | Text to render in the overlay. Plain text, or an array of segments for rich content. |
| noData.renderer | Renderer |  | A function for generating HTML element or string for overlay content. |
| noVisibleSeries | AgChartOverlayOptions |  | An overlay to be displayed when there are no series visible. |
| noVisibleSeries.enabled | boolean | true | Enabled or disable use of the overlay. |
| noVisibleSeries.text | TextValue \| ContentSegment[] |  | Text to render in the overlay. Plain text, or an array of segments for rich content. |
| noVisibleSeries.renderer | Renderer |  | A function for generating HTML element or string for overlay content. |
| unsupportedBrowser | AgChartOverlayOptions |  | An overlay to be displayed when chart is running in an unsupported browser. |
| unsupportedBrowser.enabled | boolean | true | Enabled or disable use of the overlay. |
| unsupportedBrowser.text | TextValue \| ContentSegment[] |  | Text to render in the overlay. Plain text, or an array of segments for rich content. |
| unsupportedBrowser.renderer | Renderer |  | A function for generating HTML element or string for overlay content. |


---
product: "AG Charts"
title: "Overlays"
description: "There are some options to display custom HTML over a chart."
framework: react
version: "14.2.0"
related:
    - title: "Background"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/background/"
    - title: "Colours"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/colours/"
    - title: "Fills & Borders"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/fills-borders/"
    - title: "Layout"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/layout/"
    - title: "RTL Text & Layout"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/rtl/"
    - title: "Text"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/text/"
    - title: "Themes"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/themes/"
    - title: "Background Image"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/background-image/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Overlays

There are some options to display custom HTML over a chart.

## Missing Data Overlay

Sometimes end-users can be confused if a chart doesn't have any content. To help them understand that no data has been supplied, a message is displayed over the chart area.

#### Overlay for Missing Data

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgChartOptions,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";

ModuleRegistry.registerModules([
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgChartOptions>({
    title: {
      text: "A chart with missing data",
    },
    data: [],
    series: [
      {
        type: "line",
        xKey: "year",
        yKey: "spending",
      },
    ],
    axes: {
      y: { type: "number", title: { text: "Year" } },
      x: { type: "number", title: { text: "Spending" } },
    },
    overlays: {
      noData: {
        text: "No data to display",
      },
    },
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Overlay for Missing Data](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/overlays/examples/no-data-plain/)

## No Visible Series Overlay

A message is also displayed when all series are hidden:

#### No Visible Series

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgChartOptions,
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";

ModuleRegistry.registerModules([
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgChartOptions>({
    data: [
      { quarter: "Q1", petrol: 200, diesel: 100 },
      { quarter: "Q2", petrol: 300, diesel: 130 },
      { quarter: "Q3", petrol: 350, diesel: 160 },
      { quarter: "Q4", petrol: 400, diesel: 200 },
    ],
    series: [
      { type: "line", xKey: "quarter", yKey: "petrol", visible: false },
      { type: "line", xKey: "quarter", yKey: "diesel", visible: false },
    ],
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: No Visible Series](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/overlays/examples/no-visible-series/)

## Loading Data Overlay

When using [Asynchronous Data](https://www.ag-grid.com/charts/archive/14.2.0/react/async-data/), a loading data animation is shown while waiting for a response. The overlay can also be shown or hidden manually using the `loading` option. See [Asynchronous Data — Manual Control](https://www.ag-grid.com/charts/archive/14.2.0/react/async-data/#manual-control) for details.

#### Loading Data

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgChartOptions,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  DataSourceModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-enterprise";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  DataSourceModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ContextMenuModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgChartOptions>({
    dataSource: {
      getData: () =>
        new Promise(() => {
          // Never resolve so the loading spinner remains
        }),
    },
    series: [
      {
        type: "line",
        xKey: "year",
        yKey: "spending",
      },
    ],
    axes: {
      y: { type: "number", title: { text: "Year" } },
      x: { type: "number", title: { text: "Spending" } },
    },
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Loading Data](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/overlays/examples/loading/)

## Unsupported Browser Overlay

When an [unsupported browser](https://www.ag-grid.com/charts/archive/14.2.0/react/supported-browsers/) is detected and the chart may not operate correctly, we display an overlay to make the user aware of this.

## Customisation

### Text

These messages can be customised through `overlays`:

```js
{
    overlays: {
        loading: {
            text: 'Some custom loading message',
        },
        noData: {
            text: 'Some custom noData message',
        },
        noVisibleSeries: {
            text: 'Some custom noVisibleSeries message',
        },
        unsupportedBrowser: {
            text: 'Some custom unsupportedBrowser message',
        },
    },
}
```

### Custom Overlay

If finer grained control is required, a renderer can be provided to allow full customisation:

#### Custom Overlay for Missing Data

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgChartOptions,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";

const noDataOverlay = () => {
  return [
    "<div",
    '    style="',
    "        align-items: center;",
    "        background: hsl(45deg, 100%, 90%);",
    "        border: 2px solid hsl(0deg, 100%, 75%);",
    "        box-sizing: border-box;",
    "        color: black;",
    "        display: flex;",
    "        height: calc(100% - 16px);",
    "        justify-content: center;",
    "        margin: 8px;",
    '    "',
    ">",
    "    <em>Custom message for <strong>missing data</strong></em>",
    "</div>",
  ].join("\n");
};
ModuleRegistry.registerModules([
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgChartOptions>({
    title: {
      text: "A chart with missing data",
    },
    data: [],
    series: [
      {
        type: "line",
        xKey: "year",
        yKey: "spending",
      },
    ],
    axes: {
      y: { type: "number", title: { text: "Year" } },
      x: { type: "number", title: { text: "Spending" } },
    },
    overlays: {
      noData: {
        renderer: noDataOverlay,
      },
    },
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Custom Overlay for Missing Data](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/overlays/examples/no-data/)

```js
{
    overlays: {
        noData: {
            renderer: () => '<em>Custom message for <strong>missing data</strong></em>',
        },
    },
}
```

### Custom Loading Spinner

#### Custom Overlay for Loading Data

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgChartOptions,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  DataSourceModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-enterprise";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  DataSourceModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ContextMenuModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgChartOptions>({
    dataSource: {
      getData: () =>
        new Promise(() => {
          // Never resolve so the loading spinner remains
        }),
    },
    overlays: {
      loading: {
        renderer: () => {
          const container = document.createElement("div");
          container.style.display = "flex";
          container.style.justifyContent = "center";
          container.style.alignItems = "center";
          container.style.flexDirection = "column";
          container.style.height = "100%";
          container.style.boxSizing = "border-box";
          container.style.userSelect = "none";
          container.style.animation = "loading 250ms linear 50ms both";
          const spinner = document.createElement("div");
          spinner.style.width = "100px";
          spinner.style.height = "100px";
          spinner.style.backgroundImage = [
            "linear-gradient(#333, #333)",
            "linear-gradient(#999, #999)",
            "linear-gradient(#ccc, #ccc)",
          ].join(", ");
          spinner.style.backgroundPosition = "0% 0%, 0% 100%, 100% 100%";
          spinner.style.backgroundSize = "50% 50%";
          spinner.style.backgroundRepeat = "no-repeat";
          spinner.style.animation = "loading-spinner 1s infinite";
          const animation = document.createElement("style");
          animation.innerText = [
            "@keyframes loading { from { opacity: 0 } to { opacity: 1 } }",
            "@keyframes loading-spinner {",
            "  0% { background-position: 0% 0%, 0% 100%, 100% 100%; }",
            "  25% { background-position: 100% 0%, 0% 0%, 0% 100%; }",
            "  50% { background-position: 100% 100%, 100% 0%, 0% 0%; }",
            "  75% { background-position: 0% 100%, 100% 100%, 100% 0%; }",
            "  100% { background-position: 0% 0%, 0% 100%, 100% 100%; }",
            "}",
          ].join(" ");
          container.replaceChildren(spinner, animation);
          return container;
        },
      },
    },
    series: [
      {
        type: "line",
        xKey: "year",
        yKey: "spending",
      },
    ],
    axes: {
      y: { type: "number", title: { text: "Year" } },
      x: { type: "number", title: { text: "Spending" } },
    },
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Custom Overlay for Loading Data](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/overlays/examples/loading-custom/)

```js
{
    overlays: {
        loading: {
            renderer: () => {
                const container = document.createElement('div');
                // ... styles

                const spinner = document.createElement('div');
                // ... styles

                const animation = document.createElement('style');
                // ... keyframes

                container.append(spinner, animation);

                return container;
            },
        },
    },
}
```

## API Reference

#### Overlays

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| loading | AgChartOverlayOptions |  | An overlay to be displayed when there is no data. |
| loading.enabled | boolean | true | Enabled or disable use of the overlay. |
| loading.text | TextValue \| ContentSegment[] |  | Text to render in the overlay. Plain text, or an array of segments for rich content. |
| loading.renderer | Renderer |  | A function for generating HTML element or string for overlay content. |
| noData | AgChartOverlayOptions |  | An overlay to be displayed when there is no data. |
| noData.enabled | boolean | true | Enabled or disable use of the overlay. |
| noData.text | TextValue \| ContentSegment[] |  | Text to render in the overlay. Plain text, or an array of segments for rich content. |
| noData.renderer | Renderer |  | A function for generating HTML element or string for overlay content. |
| noVisibleSeries | AgChartOverlayOptions |  | An overlay to be displayed when there are no series visible. |
| noVisibleSeries.enabled | boolean | true | Enabled or disable use of the overlay. |
| noVisibleSeries.text | TextValue \| ContentSegment[] |  | Text to render in the overlay. Plain text, or an array of segments for rich content. |
| noVisibleSeries.renderer | Renderer |  | A function for generating HTML element or string for overlay content. |
| unsupportedBrowser | AgChartOverlayOptions |  | An overlay to be displayed when chart is running in an unsupported browser. |
| unsupportedBrowser.enabled | boolean | true | Enabled or disable use of the overlay. |
| unsupportedBrowser.text | TextValue \| ContentSegment[] |  | Text to render in the overlay. Plain text, or an array of segments for rich content. |
| unsupportedBrowser.renderer | Renderer |  | A function for generating HTML element or string for overlay content. |
